import React, { useState, useRef, useCallback, useEffect, memo } from 'react';

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function _extends() {
  _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  return _extends.apply(this, arguments);
}

function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;

  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }

  return target;
}

function _objectWithoutProperties(source, excluded) {
  if (source == null) return {};

  var target = _objectWithoutPropertiesLoose(source, excluded);

  var key, i;

  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);

    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
      target[key] = source[key];
    }
  }

  return target;
}

function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
}

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

function _iterableToArrayLimit(arr, i) {
  if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return;
  var _arr = [];
  var _n = true;
  var _d = false;
  var _e = undefined;

  try {
    for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

  return arr2;
}

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

var observerErr = "💡react-cool-img: the browser doesn't support Intersection Observer, please install polyfill to enable lazy loading: https://github.com/wellyshen/react-cool-img#intersection-observer-polyfill";
var thresholdWarn = "💡react-cool-img: the threshold of observerOptions must be a number. Use 0 as fallback.";
var useObserver = (function (debounce, _ref) {
  var root = _ref.root,
      _ref$rootMargin = _ref.rootMargin,
      rootMargin = _ref$rootMargin === void 0 ? "50px" : _ref$rootMargin,
      _ref$threshold = _ref.threshold,
      threshold = _ref$threshold === void 0 ? 0.01 : _ref$threshold;

  var _useState = useState(false),
      _useState2 = _slicedToArray(_useState, 2),
      startLoad = _useState2[0],
      setStartLoad = _useState2[1];

  var _useState3 = useState(null),
      _useState4 = _slicedToArray(_useState3, 2),
      el = _useState4[0],
      setEl = _useState4[1];

  var observerRef = useRef(null);
  var timeoutRef = useRef(null);
  var erroredRef = useRef(false);
  var numThreshold = threshold;

  if (typeof threshold !== "number") {
    console.warn(thresholdWarn);
    numThreshold = 0;
  }

  var resetTimeout = useCallback(function () {
    if (!timeoutRef.current) return;
    clearTimeout(timeoutRef.current);
    timeoutRef.current = null;
  }, []);
  useEffect(function () {
    if (!("IntersectionObserver" in window) || !("IntersectionObserverEntry" in window)) {
      if (!erroredRef.current) {
        console.error(observerErr);
        erroredRef.current = true;
      }

      setStartLoad(true);
      return function () {
        return null;
      };
    } // eslint-disable-next-line compat/compat


    observerRef.current = new IntersectionObserver(function (_ref2) {
      var _ref3 = _slicedToArray(_ref2, 1),
          _ref3$ = _ref3[0],
          isIntersecting = _ref3$.isIntersecting,
          intersectionRatio = _ref3$.intersectionRatio;

      var inView = isIntersecting !== undefined ? isIntersecting : intersectionRatio > 0;

      if (inView && !startLoad) {
        timeoutRef.current = setTimeout(function () {
          setStartLoad(true);
        }, debounce);
      } else {
        resetTimeout();
      }
    }, {
      root: root,
      rootMargin: rootMargin,
      threshold: numThreshold
    });
    var observer = observerRef.current;
    if (el) observer.observe(el);
    return function () {
      observer.disconnect();
      resetTimeout();
    };
  }, [el, startLoad, root, rootMargin, numThreshold, debounce, resetTimeout]);
  return [setEl, startLoad];
});

var key = "REACT_COOL_IMG";
var set = function set(src) {
  try {
    var data = JSON.parse(sessionStorage.getItem(key) || "{}");
    data[src] = new Date();
    sessionStorage.setItem(key, JSON.stringify(data));
  } catch (error) {
    /* istanbul ignore next */
    console.error("\uD83D\uDCA1react-cool-img: ".concat(error));
  }
};
var get = function get(src) {
  try {
    var data = JSON.parse(sessionStorage.getItem(key) || "{}");
    return !!data[src];
  } catch (error) {
    /* istanbul ignore next */
    console.error("\uD83D\uDCA1react-cool-img: ".concat(error));
    /* istanbul ignore next */

    return false;
  }
};

/* eslint-disable lines-between-class-members */
var Imager = /*#__PURE__*/function () {
  function Imager() {
    _classCallCheck(this, Imager);

    _defineProperty(this, "img", null);

    _defineProperty(this, "timeout", null);

    _defineProperty(this, "retries", 1);
  }

  _createClass(Imager, [{
    key: "load",
    value: function load(src, decode, _ref, onError, onLoad, crossOrigin) {
      var _this = this;

      var _ref$count = _ref.count,
          count = _ref$count === void 0 ? 3 : _ref$count,
          _ref$delay = _ref.delay,
          delay = _ref$delay === void 0 ? 2 : _ref$delay,
          _ref$acc = _ref.acc,
          acc = _ref$acc === void 0 ? "*" : _ref$acc;
      this.img = new Image();
      this.img.src = src;
      if (crossOrigin) this.img.crossOrigin = crossOrigin;
      if (decode && this.img.decode) this.img.decode()["catch"](function () {// Ignore decoding error
      }); // @ts-expect-error

      this.img.onerror = function (event) {
        if (!count || _this.retries > count) {
          onError(event);
          return;
        }

        var time = acc === "*" ? Math.pow(delay, _this.retries) : delay * _this.retries;
        if (acc === false) time = delay;
        _this.timeout = setTimeout(function () {
          _this.clearImgSrc();

          _this.img.src = src;
        }, time * 1000);
        _this.retries += 1;
      };

      this.img.onload = function (event) {
        onLoad(event);
      };
    }
  }, {
    key: "unload",
    value: function unload() {
      if (this.img) {
        this.img.onerror = null;
        this.img.onload = null;
        this.clearImgSrc();
        this.img = null;
      }

      if (this.timeout) {
        clearTimeout(this.timeout);
        this.timeout = null;
      }

      this.retries = 1;
    }
  }, {
    key: "clearImgSrc",
    value: function clearImgSrc() {
      /* istanbul ignore next */
      this.img.src = "";
      /* istanbul ignore next */

      try {
        /* istanbul ignore next */
        // @ts-ignore
        delete this.img.src;
      } catch (error) {// Ignore the error of deleting object properties in Safari strict mode
      }
    }
  }]);

  return Imager;
}();

var Img = function Img(_ref) {
  var _ref$className = _ref.className,
      className = _ref$className === void 0 ? "" : _ref$className,
      placeholder = _ref.placeholder,
      src = _ref.src,
      error = _ref.error,
      crossOrigin = _ref.crossOrigin,
      _ref$decode = _ref.decode,
      decode = _ref$decode === void 0 ? true : _ref$decode,
      _ref$lazy = _ref.lazy,
      lazy = _ref$lazy === void 0 ? true : _ref$lazy,
      _ref$cache = _ref.cache,
      cache = _ref$cache === void 0 ? true : _ref$cache,
      _ref$debounce = _ref.debounce,
      debounce = _ref$debounce === void 0 ? 300 : _ref$debounce,
      _ref$observerOptions = _ref.observerOptions,
      observerOptions = _ref$observerOptions === void 0 ? {} : _ref$observerOptions,
      _ref$retry = _ref.retry,
      retry = _ref$retry === void 0 ? {} : _ref$retry,
      srcSet = _ref.srcSet,
      sizes = _ref.sizes,
      onError = _ref.onError,
      onLoad = _ref.onLoad,
      rest = _objectWithoutProperties(_ref, ["className", "placeholder", "src", "error", "crossOrigin", "decode", "lazy", "cache", "debounce", "observerOptions", "retry", "srcSet", "sizes", "onError", "onLoad"]);

  var imagerRef = useRef(new Imager());

  var _useObserver = useObserver(debounce, observerOptions),
      _useObserver2 = _slicedToArray(_useObserver, 2),
      setRef = _useObserver2[0],
      startLoad = _useObserver2[1];

  var _useState = useState(placeholder || "data:image/gif;base64,R0lGODlhAQABAIAAAP///wAAACH5BAEAAAAALAAAAAABAAEAAAICRAEAOw=="),
      _useState2 = _slicedToArray(_useState, 2),
      source = _useState2[0],
      setSource = _useState2[1];

  var isSrc = source === src;
  var filename = src ? src.replace(/^.*[\\/]/, "").split(".")[0] : "";

  var handleError = function handleError(event) {
    if (onError) onError(event);

    if (error) {
      setSource(error);
    } else if (placeholder) {
      setSource(placeholder);
    }
  };

  var handleLoad = function handleLoad(event) {
    if (onLoad) onLoad(event);
    setSource(src);
    if (cache) set(src);
  };

  useEffect(function () {
    var imager = imagerRef.current;

    var loadImg = function loadImg() {
      imager.load(src, decode, retry, handleError, handleLoad, crossOrigin);
    };

    if (!lazy || cache && get(src)) {
      loadImg();
    } else if (startLoad) {
      loadImg();
    }

    return function () {
      imager.unload();
    };
  }, [cache, startLoad, src, crossOrigin, decode, retry]);
  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("img", _extends({
    className: "".concat(className, " no-js-").concat(filename),
    src: source,
    crossOrigin: isSrc ? crossOrigin : undefined,
    srcSet: isSrc ? srcSet : undefined,
    sizes: isSrc ? sizes : undefined,
    ref: setRef
  }, rest)), /*#__PURE__*/React.createElement("noscript", null, /*#__PURE__*/React.createElement("style", null, ".no-js-".concat(filename, " { display: none !important; }")), /*#__PURE__*/React.createElement("img", _extends({
    className: className,
    src: src,
    crossOrigin: crossOrigin,
    srcSet: srcSet,
    sizes: sizes
  }, rest))));
};

var index = /*#__PURE__*/memo(Img);

export default index;
